(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Programm: Main
 * Datei: FB_HOLDX_R2.st
 * Autor: Administrator
 * Erstellt: 28. April 2021
 ********************************************************************
 * Implementierung des Programms Main
 ********************************************************************) 

(*  *)
FUNCTION_BLOCK FB_HOLDX_R2

(* ################################################################################################### *)
(* Auswertung Eingangsdaten von HOLDX *)
(* ################################################################################################### *)

(* Abfrage Vorgabe Anzahl HoldX korrekt *)
	IF iAnzHoldX < 1 THEN
		iErrorCode := 9999;
		iErrorHoldX := 9999;
		RETURN;
	ELSE
		iAnzSigInt := iAnzHoldX;
	END_IF

	IF iAnzHoldX > 30 THEN
		iErrorCode := 9998;
		iErrorHoldX := 9999;
		RETURN;
	ELSE
		iAnzSigInt := iAnzHoldX;
	END_IF

	IF timTelegramPause = T#0MS THEN
		iErrorCode	:= 9996;
		iErrorHoldX := 9999;
		RETURN;
	END_IF

	 
	(* Reset Neustart *)
	TOF_ClockNeu(IN := xInClock,
		PT := timTelegramPause);

	F_TRIG_DatenAusgabe(CLK :=TOF_ClockNeu.Q);
  
			  
	IF F_TRIG_DatenAusgabe.Q THEN
		iCaseOutSwitchOld := iCaseOutSwitch;
		iCaseOutSwitch := 0;
	END_IF


	(*---------------------------------*)


	(* Zhlen Clock Ereignisse *)
	F_TRIG_ClockIn(CLK := xInClock);

	IF F_TRIG_ClockIn.Q THEN
		iCaseOutSwitch := iCaseOutSwitch + 1;
	END_IF;



	(* Zuweisung Info Bit *)
	IF F_TRIG_DatenAusgabe.Q THEN
		aInfoBitOld := aInfoBit;
		FOR i := 0 TO 43 DO
			aInfoBit[i] := FALSE;
		END_FOR
	END_IF

	IF iCaseOutSwitch > 0 THEN
		IF F_TRIG_ClockIn.Q THEN
			aInfoBit[iCaseOutSwitch-1] := xSeriellDataIn;
		END_IF
	END_IF


	(* Ausgabe der empfangenen Daten *)
	IF F_TRIG_DatenAusgabe.Q THEN
		IF iCaseOutSwitchOld = 3 THEN 	(* Ausgabe wenn nur die ersten 3 Bit ausgegeben werden = Alle gleicher Zustand *)
		
			(* Info Ausgabe "Alle Magnete SAFE" *)
			FOR i:=1 TO 30 DO
				aSafeOK[i]:=FALSE;
			END_FOR
			IF aInfoBitOld[0] THEN
				FOR i:=1 TO iAnzHoldX DO
					aSafeOK[i]:=TRUE;
				END_FOR
			END_IF
		
			(* Info Ausgabe "Alle Magnete Lock" *)
			FOR i:=1 TO 30 DO
				aLockOK[i]:=FALSE;
			END_FOR
			IF aInfoBitOld[1] THEN
				FOR i:=1 TO iAnzHoldX DO
					aLockOK[i]:=TRUE;
				END_FOR
			END_IF
     
			iErrorCode := 0;
			iErrorHoldX := 0;

        
		ELSIF iCaseOutSwitchOld = (3 + 1 + iAnzHoldX) THEN  	(* Ausgabe wenn alle Bit ausgegeben werden (ohne Fehler) = ungleicher Zustand angeschlossene HoldX *)
		
			(* Info Ausgabe "Magnete SAFE" *)
			IF aInfoBitOld[0] THEN (* Alle angeschlossenen SAFE, aber auch Telegramm LOCK individuell *)
				FOR i:=1 TO 30 DO
					aSafeOK[i]:=FALSE;
				END_FOR
				FOR i:=1 TO iAnzHoldX DO
					aSafeOK[i]:=TRUE;
				END_FOR
			ELSIF aInfoBitOld[3] THEN (* Nicht alle angeschlossenen SAFE *)
				FOR i:=1 TO iAnzHoldX DO
					aSafeOK[i]:=aInfoBitOld[i+3];
				END_FOR
				FOR i:=iAnzHoldX+1 TO 30 DO
					aSafeOK[i]:=FALSE;
				END_FOR
			END_IF

		
			(* Info Ausgabe "Magnete Lock" *)
			IF aInfoBitOld[1] THEN (* Alle angeschlossenen LOCK, aber auch Telegramm SAFE individuell *)
				FOR i:=1 TO 30 DO
					aLockOK[i]:=FALSE;
				END_FOR
				FOR i:=1 TO iAnzHoldX DO
					aLockOK[i]:=TRUE;
				END_FOR
			ELSIF NOT aInfoBitOld[3] THEN (* Nicht alle angeschlossenen LOCK *)
				FOR i:=1 TO iAnzHoldX DO
					aLockOK[i]:=aInfoBitOld[i+3];
				END_FOR
				FOR i:=iAnzHoldX+1 TO 30 DO
					aLockOK[i]:=FALSE;
				END_FOR
			END_IF
        
			iErrorCode := 0;
			iErrorHoldX := 0;
        
		ELSIF iCaseOutSwitchOld = (3 + 1 + iAnzHoldX + 10) THEN			(* Ausgabe wenn alle Bit ausgegeben werden (mit Fehler) = ungleicher Zustand angeschlossene HoldX *)
			(* Info Ausgabe "Magnete SAFE" *)
			IF aInfoBitOld[0] THEN (* Alle angeschlossenen SAFE, aber auch Telegramm LOCK individuell *)
				FOR i:=1 TO 30 DO
					aSafeOK[i]:=FALSE;
				END_FOR
				FOR i:=1 TO iAnzHoldX DO
					aSafeOK[i]:=TRUE;
				END_FOR
			ELSIF aInfoBitOld[3] THEN (* Nicht alle angeschlossenen SAFE *)
				FOR i:=1 TO iAnzHoldX DO
					aSafeOK[i]:=aInfoBitOld[i+3];
				END_FOR
				FOR i:=iAnzHoldX+1 TO 30 DO
					aSafeOK[i]:=FALSE;
				END_FOR
			END_IF

		
			(* Info Ausgabe "Magnete Lock" *)
			IF aInfoBitOld[1] THEN (* Alle angeschlossenen LOCK, aber auch Telegramm SAFE individuell *)
				FOR i:=1 TO 30 DO
					aLockOK[i]:=FALSE;
				END_FOR
				FOR i:=1 TO iAnzHoldX DO
					aLockOK[i]:=TRUE;
				END_FOR
			ELSIF NOT aInfoBitOld[3] THEN (* Nicht alle angeschlossenen LOCK *)
				FOR i:=1 TO iAnzHoldX DO
					aLockOK[i]:=aInfoBitOld[i+3];
				END_FOR
				FOR i:=iAnzHoldX+1 TO 30 DO
					aLockOK[i]:=FALSE;
				END_FOR
			END_IF
        
			(* Fehlerhafe HoldX ID ermitteln *)
			iErrorHoldX := 0;
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 0] = TRUE THEN
				iErrorHoldX := iErrorHoldX + 1;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 1] = TRUE THEN
				iErrorHoldX := iErrorHoldX + 2;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 2] = TRUE THEN
				iErrorHoldX := iErrorHoldX + 4;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 3] = TRUE THEN
				iErrorHoldX := iErrorHoldX + 8;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 4] = TRUE THEN
				iErrorHoldX := iErrorHoldX + 16;
			END_IF
        
        
        
			(* Error Code ermitteln *)
			iErrorCode := 0;
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 5] = TRUE THEN
				iErrorCode := iErrorCode + 1;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 6] = TRUE THEN
				iErrorCode := iErrorCode + 2;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 7] = TRUE THEN
				iErrorCode := iErrorCode + 4;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 8] = TRUE THEN
				iErrorCode := iErrorCode + 8;
			END_IF
        
			IF aInfoBitOld[3 + 1 + iAnzHoldX + 9] = TRUE THEN
				iErrorCode := iErrorCode + 16;
			END_IF
        
		ELSE
        
			iErrorCode := 9995;
			iErrorHoldX := 9999;
        
		END_IF
    

    
	END_IF

	(* Ausgabe dWORD HoldX Status SAFE & LOCK *)
	dwHoldX_LockOK:=0;
	dwHoldX_SafeOK:=0;
	dwMaskeIn:=1;
	FOR i:=1 TO 30 DO
		IF aSafeOK[i] THEN
			dwHoldX_SafeOK:=dwHoldX_SafeOK OR dwMaskeIn;
		END_IF
		IF aLockOK[i] THEN
			dwHoldX_LockOK:=dwHoldX_LockOK OR dwMaskeIn;
		END_IF	
		dwMaskeIn:=SHL(dwMaskeIn,1);
	END_FOR
	

	(* berwachung Kommunikation - Timeout *)
	TON_KommunikationOK(IN := NOT TOF_ClockNeu.Q,
	PT := T#5S);

	IF TON_KommunikationOK.Q THEN
		iErrorCode := 9997;
		iErrorHoldX := 9999;
		xBluetoothChange:=TRUE;
		xRastkraft0N_Store:=TRUE;
		xRastkraft30N_Store:=TRUE;
		xRastkraft50N_Store:=TRUE;		 
	END_IF

	(* berwachung Kommunikation - Keine Pause erkannt *)
	IF iCaseOutSwitch > 44 THEN
		iErrorCode := 9996;
		iErrorHoldX := 9999;
	ELSIF NOT TOF_ClockNeu.Q AND iCaseOutSwitch <= 44 AND iErrorCode = 9996 THEN
		iErrorCode := 0;
		iErrorHoldX := 0;
	END_IF

	IF iErrorCode >= 9000 THEN
		dwHoldX_SafeOK:=0;
		dwHoldX_LockOK:=0;
	END_IF




	(* ################################################################################################### *)
	(* Ausgabe Befehle an HOLDX *)
	(* ################################################################################################### *)

	(* Zuweisung Ansteuer Bits an Array zur internen Verarbeitung *)
	IF NOT xIndividualAusgabeAktiv AND NOT xAlleAusgabeAktiv THEN
		FOR i:=1 TO 30 DO
			aTuerAnsteuer[i]:=aHoldX_Command[i].xMagnetEin;
		END_FOR	
	END_IF

	(* nderung Rastkraft Vorgabe 0 N *)
	dwRastkraft0N_Old:=dwRastkraft0N;
	dwRastkraft0N:=0;
	dwMaskeOut:=1;
	FOR i:=1 TO 30 DO
		IF aHoldX_Command[i].xRastkraft_0N THEN
			dwRastkraft0N:=dwRastkraft0N OR dwMaskeOut;
		END_IF
		dwMaskeOut:=SHL(dwMaskeOut,1);
	END_FOR

	(* nderung Rastkraft Vorgabe 30 N *)
	dwRastkraft30N_Old:=dwRastkraft30N;
	dwRastkraft30N:=0;
	dwMaskeOut:=1;
	FOR i:=1 TO 30 DO
		IF aHoldX_Command[i].xRastkraft_30N THEN
			dwRastkraft30N:=dwRastkraft30N OR dwMaskeOut;
		END_IF
		dwMaskeOut:=SHL(dwMaskeOut,1);
	END_FOR

	(* nderung Rastkraft Vorgabe 50 N *)
	dwRastkraft50N_Old:=dwRastkraft50N;
	dwRastkraft50N:=0;
	dwMaskeOut:=1;
	FOR i:=1 TO 30 DO
		IF aHoldX_Command[i].xRastkraft_50N THEN
			dwRastkraft50N:=dwRastkraft50N OR dwMaskeOut;
		END_IF
		dwMaskeOut:=SHL(dwMaskeOut,1);
	END_FOR


	(* Abfrage Vorgabe Anzahl HoldX korrekt *)
	IF iAnzHoldX < 1 THEN
		RETURN;
	ELSE
		iAnzahlHolX := iAnzHoldX;
	END_IF

	IF iAnzHoldX > 30 THEN
		RETURN;
	ELSE
		iAnzahlHolX := iAnzHoldX;
	END_IF

	IF timSignalDauer = T#0MS THEN
		RETURN;
	END_IF

	IF timTelegramPause = T#0MS THEN
		iErrorCode	:= 8999;
		iErrorHoldX := 9999;
		RETURN;
	END_IF

	IF timTelegramPause < timSignalDauer THEN
		iErrorCode	:= 8998;
		iErrorHoldX := 9999;
		RETURN;	
	END_IF

	xFehlerDatumUhrzeit:=FALSE;		 
	IF usiJahr > 100 THEN
		iErrorCode	:= 8980;
		iErrorHoldX := 9999;
		xFehlerDatumUhrzeit:=TRUE;		 
	END_IF	

	IF usiMonat > 12 OR usiMonat < 1 THEN
		iErrorCode	:= 8981;
		iErrorHoldX := 9999;
		xFehlerDatumUhrzeit:=TRUE;		 
	END_IF	 
	 
	IF usiTag > 31 OR usiTag < 1 THEN
		iErrorCode	:= 8982;
		iErrorHoldX := 9999;
		xFehlerDatumUhrzeit:=TRUE;		 
	END_IF	 
	 		  
	IF usiStunde > 23 THEN
		iErrorCode	:= 8983;
		iErrorHoldX := 9999;
		xFehlerDatumUhrzeit:=TRUE;		 
	END_IF			  
	 		  
	IF usiMinute > 59 THEN
		iErrorCode	:= 8984;
		iErrorHoldX := 9999;
		xFehlerDatumUhrzeit:=TRUE;		 
	END_IF	

	FOR i:=1 TO iAnzahlHolX DO
		iTestCommand:=0;
		IF 	aHoldX_Command[i].xRastkraft_0N THEN
			iTestCommand:=iTestCommand+1;
		END_IF
		IF 	aHoldX_Command[i].xRastkraft_30N THEN
			iTestCommand:=iTestCommand+1;
		END_IF		
		IF 	aHoldX_Command[i].xRastkraft_50N THEN
			iTestCommand:=iTestCommand+1;
		END_IF   

		IF iTestCommand <> 1 THEN
			iErrorCode	:= 8997;
			iErrorHoldX := 9999;
			xTestError:=TRUE; 
			EXIT;
		END_IF			 
	END_FOR
			   
	(* Alle vorhandenen HoldX auf Zu angesteuert *)
	xAlleZu := TRUE;
    
	FOR i := 1 TO iAnzahlHolX DO
		IF aTuerAnsteuer[i] = FALSE THEN
			xAlleZu := FALSE;
			EXIT;
		END_IF
	END_FOR



	(* Alle vorhandenen HoldX auf Auf angesteuert *)
	xAlleAuf := TRUE;

	FOR i := 1 TO iAnzahlHolX DO
		IF aTuerAnsteuer[i] = TRUE THEN
			xAlleAuf := FALSE;
			EXIT;
		END_IF
	END_FOR



	(* Ausgabe serielle Bitfolge zur Ansteuerung *)
	TP_Takt(IN:=NOT TP_Takt.Q,PT:=timSignalDauer);


	R_TRIG_Freq(CLK:=TP_Takt.Q);

	TOF_Takt(IN := R_TRIG_Freq.Q,
	PT := timSignalDauer/2);

	xTakt := TOF_Takt.Q;

	R_TRIG_ClockOut(CLK := xTakt);
	F_TRIG_ClockOut(CLK := xTakt);


	IF xAlleAusgabeAktiv  THEN (* Ansteuerung aller HoldX mit kurzer Bitfolge *)
		IF xAlleZu AND NOT xAlleAuf THEN
			CASE iStep OF
				0:	
					IF R_TRIG_ClockOut.Q THEN
						iStep := iStep + 1;
					END_IF
                	
		
				1:
					xSeriellDataOut := TRUE; (* Alle Zu Bit *)
                
					IF R_TRIG_ClockOut.Q THEN
						iStep := iStep + 1;
					END_IF
                
				2:
					xSeriellDataOut := FALSE; (* Alle Auf Bit *)
                
					IF R_TRIG_ClockOut.Q THEN
						iStep := iStep + 1;
					END_IF
				
				3:
					xSeriellDataOut := FALSE;
                
					IF R_TRIG_ClockOut.Q THEN
						xAlleAusgabeAktiv := FALSE;
						xSeriellDataOut := FALSE;
					END_IF
			END_CASE
		END_IF
		IF xAlleAuf THEN
			CASE iStep OF
				0:
					IF R_TRIG_ClockOut.Q THEN
						iStep := iStep + 1;
					END_IF


				1:
					xSeriellDataOut := FALSE; (* Alle Zu Bit *)
                
					IF R_TRIG_ClockOut.Q THEN
						iStep := iStep + 1;
					END_IF
                
				2:
					xSeriellDataOut := TRUE; (* Alle Auf Bit *)
                
					IF R_TRIG_ClockOut.Q THEN
						iStep := iStep + 1;
					END_IF

				3:
					xSeriellDataOut := FALSE; (* Datum / Uhrzeit Bit *)
                
					IF R_TRIG_ClockOut.Q THEN
						xAlleAusgabeAktiv := FALSE;
						xIndividualAusgabeAktiv:=FALSE;
						xSeriellDataOut := FALSE;					
					END_IF
			END_CASE
		END_IF
	END_IF
    

	IF xIndividualAusgabeAktiv THEN (* Individuelle Ansteuerung aller angeschlossenen HoldX *)
		CASE iStep OF
			0:
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF	
	
			1:	IF iCountLogger = 1 THEN
					xLoggerAktiv:=TRUE;
				END_IF
				xSeriellDataOut := FALSE; (* Alle Zu Bit *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			2:
				xSeriellDataOut := FALSE; (* Alle Auf Bit *)
             
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
			
			3:
				xSeriellDataOut := FALSE; (* Datum / Uhrzeit Bit *)
            
				i2 := 1;
            
				IF R_TRIG_ClockOut.Q THEN (* Datum / Uhrzeit Bit *)
					iStep := iStep + 1;
				END_IF			
            
			4:
				xSeriellDataOut := aTuerAnsteuer[i2]; (* 1. HoldX *)
            
				IF R_TRIG_ClockOut.Q AND i2 < iAnzahlHolX THEN
					i2 := i2 + 1;
				ELSIF R_TRIG_ClockOut.Q AND i2 >= iAnzahlHolX THEN
					xAlleAusgabeAktiv := FALSE;
					xIndividualAusgabeAktiv:=FALSE;
					xSeriellDataOut := FALSE;
					xLoggerAktiv:=FALSE;				
				END_IF
		END_CASE
	END_IF


	(* Bluetooth Erweiterung *)

	IF xBluetootAusgabe THEN (* Individuelle Ansteuerung aller angeschlossenen HoldX fr Bluetooth *)
		CASE iStep OF
			0:
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF		
	
			1:
				xSeriellDataOut := TRUE; (* Alle Zu Bit *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			2:
				xSeriellDataOut := TRUE; (* Alle Auf Bit *)
                       
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
			
			3:
				xSeriellDataOut := FALSE; (* Datum / Uhrzeit Bit *)
            
				i2 := 1;
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF			
            
			4:
				IF xBluetoothEin THEN
					xSeriellDataOut := TRUE;
				ELSE
					xSeriellDataOut := FALSE;
				END_IF
            
				IF R_TRIG_ClockOut.Q AND i2 < iAnzahlHolX THEN
					i2 := i2 + 1;
				ELSIF R_TRIG_ClockOut.Q AND i2 >= iAnzahlHolX THEN
					xAlleAusgabeAktiv := FALSE;
					xIndividualAusgabeAktiv:=FALSE;
					xBluetoothChange:=FALSE;
					xBluetootAusgabe:=FALSE;
					xSeriellDataOut := FALSE;
					xRastkraftAusgabe50N:=FALSE;				
				END_IF
		END_CASE
    
    
    
	END_IF

	(* Datum / Uhrzeit Erweiterung *)
	IF xDatumUhrzeitAusgabe THEN (* Individuelle Ansteuerung aller angeschlossenen HoldX fr Bluetooth *)
		(* Umkopieren Minuten *)
		aDatumUhrzeit[1]:=usiMinute.0;
		aDatumUhrzeit[2]:=usiMinute.1;
		aDatumUhrzeit[3]:=usiMinute.2;
		aDatumUhrzeit[4]:=usiMinute.3;
		aDatumUhrzeit[5]:=usiMinute.4;
		aDatumUhrzeit[6]:=usiMinute.5;

		(* Umkopieren Stunden *)
		aDatumUhrzeit[7]:=usiStunde.0;
		aDatumUhrzeit[8]:=usiStunde.1;
		aDatumUhrzeit[9]:=usiStunde.2;
		aDatumUhrzeit[10]:=usiStunde.3;
		aDatumUhrzeit[11]:=usiStunde.4;

		(* Umkopieren Tag *)
		aDatumUhrzeit[12]:=usiTag.0;
		aDatumUhrzeit[13]:=usiTag.1;
		aDatumUhrzeit[14]:=usiTag.2;
		aDatumUhrzeit[15]:=usiTag.3;
		aDatumUhrzeit[16]:=usiTag.4;
	
		(* Umkopieren Monat *)
		aDatumUhrzeit[17]:=usiMonat.0;
		aDatumUhrzeit[18]:=usiMonat.1;
		aDatumUhrzeit[19]:=usiMonat.2;
		aDatumUhrzeit[20]:=usiMonat.3;
	
		(* Umkopieren Jahr *)
		aDatumUhrzeit[21]:=usiJahr.0;
		aDatumUhrzeit[22]:=usiJahr.1;
		aDatumUhrzeit[23]:=usiJahr.2;
		aDatumUhrzeit[24]:=usiJahr.3;
		aDatumUhrzeit[25]:=usiJahr.4;
		aDatumUhrzeit[26]:=usiJahr.5;	
		aDatumUhrzeit[27]:=usiJahr.6;	
		
		CASE iStep OF
			0:
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF		
		
			1:
				xSeriellDataOut := FALSE; (* Alle Zu Bit *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			2:
				xSeriellDataOut := FALSE; (* Alle Auf Bit *)
                       
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
			
			3:
				xSeriellDataOut := TRUE; (* Datum / Uhrzeit Bit *)
            
				i2 := 1;
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF			
            
			4:
				xSeriellDataOut := aDatumUhrzeit[i2]; 
            
				IF R_TRIG_ClockOut.Q AND i2 < 27 THEN
					i2 := i2 + 1;
				ELSIF R_TRIG_ClockOut.Q AND i2 >= 27 THEN
					xAlleAusgabeAktiv := FALSE;
					xIndividualAusgabeAktiv:=FALSE;
					xSeriellDataOut := FALSE;
					xDatumUhrzeitAusgabe:=FALSE;
					xSetTime_Store:=FALSE;
					xRastkraftAusgabe50N:=FALSE;
				END_IF    
		END_CASE
	END_IF



	(* Rastkraft Erweiterung *)

	IF xRastkraftAusgabe50N THEN (* Individuelle Ansteuerung aller angeschlossenen HoldX fr Bluetooth *)
		CASE iStep OF
			0:
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF		
		
			1:	IF iCountLogger = 1 THEN
					xLoggerAktiv:=TRUE;
				END_IF
			
				xSeriellDataOut := TRUE; (* Alle Zu Bit *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			2:
				xSeriellDataOut := FALSE; (* Alle Auf Bit *)
             
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
			
			3:
				xSeriellDataOut := TRUE; (* Datum / Uhrzeit Bit *)
            
				i2 := 1;
            
				IF R_TRIG_ClockOut.Q THEN (* Datum / Uhrzeit Bit *)
					iStep := iStep + 1;
				END_IF			
            
			4:
				xSeriellDataOut := aHoldX_Command[i2].xRastkraft_50N; (* 1. HoldX *)
            
				IF R_TRIG_ClockOut.Q AND i2 < iAnzahlHolX THEN
					i2 := i2 + 1;
				ELSIF R_TRIG_ClockOut.Q AND i2 >= iAnzahlHolX THEN
					iStep := iStep + 1;
				END_IF
			
			5:	
				xSeriellDataOut := FALSE; (* Rastkraft Codierung *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			6:	
				xSeriellDataOut := TRUE; (* Rastkraft Codierung *)
            
				IF R_TRIG_ClockOut.Q THEN
					xAlleAusgabeAktiv := FALSE;
					xIndividualAusgabeAktiv:=FALSE;
					xBluetootAusgabe:=FALSE;
					xSeriellDataOut := FALSE;
					xRastkraftAusgabe50N:=FALSE;
					xRastkraft50N_Store:=FALSE;
					xLoggerAktiv:=FALSE;
				END_IF			
		END_CASE
	END_IF

	IF xRastkraftAusgabe30N THEN (* Individuelle Ansteuerung aller angeschlossenen HoldX fr Bluetooth *)
		CASE iStep OF
			0:
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF		
		
			1:	IF iCountLogger = 1 THEN
					xLoggerAktiv:=TRUE;
				END_IF
			
				xSeriellDataOut := TRUE; (* Alle Zu Bit *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			2:
				xSeriellDataOut := FALSE; (* Alle Auf Bit *)
             
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
			
			3:
				xSeriellDataOut := TRUE; (* Datum / Uhrzeit Bit *)
            
				i2 := 1;
            
				IF R_TRIG_ClockOut.Q THEN (* Datum / Uhrzeit Bit *)
					iStep := iStep + 1;
				END_IF			
            
			4:
				xSeriellDataOut := aHoldX_Command[i2].xRastkraft_30N; (* 1. HoldX *)
            
				IF R_TRIG_ClockOut.Q AND i2 < iAnzahlHolX THEN
					i2 := i2 + 1;
				ELSIF R_TRIG_ClockOut.Q AND i2 >= iAnzahlHolX THEN
					iStep := iStep + 1;
				END_IF
			
			5:	
				xSeriellDataOut := TRUE; (* Rastkraft Codierung *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			6:	
				xSeriellDataOut := FALSE; (* Rastkraft Codierung *)
            
				IF R_TRIG_ClockOut.Q THEN
					xAlleAusgabeAktiv := FALSE;
					xIndividualAusgabeAktiv:=FALSE;
					xBluetootAusgabe:=FALSE;
					xSeriellDataOut := FALSE;
					xRastkraftAusgabe30N:=FALSE;
					xRastkraft30N_Store:=FALSE;
					xLoggerAktiv:=FALSE;
				END_IF			
		END_CASE
	END_IF


	IF xRastkraftAusgabe0N THEN (* Individuelle Ansteuerung aller angeschlossenen HoldX fr Bluetooth *)
		CASE iStep OF
			0:
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF		
		
			1:	IF iCountLogger = 1 THEN
					xLoggerAktiv:=TRUE;
				END_IF
			
				xSeriellDataOut := TRUE; (* Alle Zu Bit *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			2:
				xSeriellDataOut := FALSE; (* Alle Auf Bit *)
             
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
			
			3:
				xSeriellDataOut := TRUE; (* Datum / Uhrzeit Bit *)
            
				i2 := 1;
            
				IF R_TRIG_ClockOut.Q THEN (* Datum / Uhrzeit Bit *)
					iStep := iStep + 1;
				END_IF			
            
			4:
				xSeriellDataOut := aHoldX_Command[i2].xRastkraft_0N; (* 1. HoldX *)
            
				IF R_TRIG_ClockOut.Q AND i2 < iAnzahlHolX THEN
					i2 := i2 + 1;
				ELSIF R_TRIG_ClockOut.Q AND i2 >= iAnzahlHolX THEN
					iStep := iStep + 1;
				END_IF
			
			5:	
				xSeriellDataOut := FALSE; (* Rastkraft Codierung *)
            
				IF R_TRIG_ClockOut.Q THEN
					iStep := iStep + 1;
				END_IF
            
			6:	
				xSeriellDataOut := FALSE; (* Rastkraft Codierung *)
            
				IF R_TRIG_ClockOut.Q THEN
					xAlleAusgabeAktiv := FALSE;
					xIndividualAusgabeAktiv:=FALSE;
					xBluetootAusgabe:=FALSE;
					xSeriellDataOut := FALSE;
					xRastkraftAusgabe0N:=FALSE;
					xRastkraft0N_Store:=FALSE;
					xLoggerAktiv:=FALSE;
				END_IF			
		END_CASE
	END_IF

	(* Ausgabe Steuerung - welche Bitfolge / Art *)
	R_TRIG_Bluetooth(CLK:=xBluetoothEin);
	F_TRIG_Bluetooth(CLK:=xBluetoothEin);
	R_TRIG_SetTime(CLK:=xSetDateTime);
	R_TRIG_Rastkraft0N(CLK:=dwRastkraft0N > dwRastkraft0N_Old);
	R_TRIG_Rastkraft30N(CLK:=dwRastkraft30N > dwRastkraft30N_Old);
	R_TRIG_Rastkraft50N(CLK:=dwRastkraft50N > dwRastkraft50N_Old);

	
	IF R_TRIG_Bluetooth.Q OR F_TRIG_Bluetooth.Q THEN
		xBluetoothChange:=TRUE;
	END_IF

	IF R_TRIG_SetTime.Q THEN
		xSetTime_Store:=TRUE;
	END_IF

	IF R_TRIG_Rastkraft0N.Q THEN
		xRastkraft0N_Store:=TRUE;
	END_IF

	IF R_TRIG_Rastkraft30N.Q THEN
		xRastkraft30N_Store:=TRUE;
	END_IF

	IF R_TRIG_Rastkraft50N.Q THEN
		xRastkraft50N_Store:=TRUE;
	END_IF

	IF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND xSetTime_Store 
		AND NOT xBluetootAusgabe AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q AND NOT xFehlerDatumUhrzeit THEN
		xDatumUhrzeitAusgabe:=TRUE;
	ELSIF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND xRastkraft50N_Store 
		AND NOT xBluetootAusgabe AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q THEN
		xRastkraftAusgabe50N:=TRUE;	
	ELSIF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND xRastkraft30N_Store 
		AND NOT xBluetootAusgabe AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q THEN
		xRastkraftAusgabe30N:=TRUE;	
	ELSIF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND xRastkraft0N_Store 
		AND NOT xBluetootAusgabe AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q THEN
		xRastkraftAusgabe0N:=TRUE;	
	ELSIF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND xBluetoothChange 
		AND NOT xBluetootAusgabe AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q THEN
		xBluetootAusgabe:=TRUE;	
	ELSIF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND NOT xBluetootAusgabe AND NOT xBluetoothChange
		AND (xAlleAuf OR xAlleZu)AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q THEN
		xAlleAusgabeAktiv := TRUE;
	ELSIF NOT TOF_AusgabeAktiv.Q AND NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND NOT xBluetootAusgabe AND NOT xBluetoothChange
		AND NOT xAlleAuf AND NOT xAlleZu AND NOT xDatumUhrzeitAusgabe AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N 
		AND NOT xRastkraftAusgabe0N AND F_TRIG_ClockOut.Q THEN
		xIndividualAusgabeAktiv := TRUE;
	END_IF



	(* Ausgabe Clock Signal *)
	TOF_AusgabeAktiv(IN := xAlleAusgabeAktiv OR xIndividualAusgabeAktiv OR xBluetootAusgabe OR xDatumUhrzeitAusgabe OR xRastkraftAusgabe0N OR xRastkraftAusgabe30N OR xRastkraftAusgabe50N,
	PT := timTelegramPause);


	xClockOut :=TOF_Takt.Q AND (xAlleAusgabeAktiv OR xIndividualAusgabeAktiv OR xBluetootAusgabe OR xDatumUhrzeitAusgabe OR xRastkraftAusgabe0N OR xRastkraftAusgabe30N OR xRastkraftAusgabe50N);

	IF NOT xAlleAusgabeAktiv AND NOT xIndividualAusgabeAktiv AND NOT xBluetootAusgabe AND NOT xDatumUhrzeitAusgabe 
		AND NOT xRastkraftAusgabe50N AND NOT xRastkraftAusgabe30N AND NOT xRastkraftAusgabe0N THEN
		iStep := 0;
	END_IF

	
END_FUNCTION_BLOCK
